class ApcoUtils {
  static String formatDateTime(DateTime inputDate, int format) {
    String _output = "";
    switch (format) {
      case 0:
        _output = inputDate.hour.toString() +
            ":" +
            inputDate.minute.toString() +
            ":" +
            inputDate.second.toString();
        break;
      case 1:
        _output = inputDate.year.toString().padLeft(2, '0') +
            "/" +
            inputDate.month.toString().padLeft(2, '0') +
            "/" +
            inputDate.day.toString().padLeft(2, '0') +
            "  " +
            inputDate.hour.toString().padLeft(2, '0') +
            ":" +
            inputDate.minute.toString().padLeft(2, '0') +
            ":" +
            inputDate.second.toString().padLeft(2, '0');
        break;
      case 2:
        _output = inputDate.year.toString().padLeft(2, '0') +
            "/" +
            inputDate.month.toString().padLeft(2, '0') +
            "/" +
            inputDate.day.toString().padLeft(2, '0') +
            "  " +
            inputDate.hour.toString().padLeft(2, '0') +
            ":" +
            inputDate.minute.toString().padLeft(2, '0');
        break;
      case 3:
        _output = inputDate.hour.toString().padLeft(2, '0') +
            ":" +
            inputDate.minute.toString().padLeft(2, '0');

        break;
      case 4:
        _output = inputDate.hour.toString().padLeft(2, '0') +
            ":" +
            inputDate.minute.toString().padLeft(2, '0') +
            ":" +
            inputDate.second.toString().padLeft(2, '0');

        break;
      default:
        _output = "?";
    }

    return _output;
  }

  static String persianDayOfWeek(DateTime grDate) {
    String strOut = "_";
    switch (grDate.weekday) {
      case 6:
        strOut = "شنبه";
        break;
      case 7:
        strOut = "یکشنبه";
        break;
      case 1:
        strOut = "دوشنبه";
        break;
      case 2:
        strOut = "سه شنبه";
        break;
      case 3:
        strOut = "چهارشنبه";
        break;
      case 4:
        strOut = "پنجشنبه";
        break;
      case 5:
        strOut = "جمعه";
        break;
    }
    return (strOut);
  }

  static String persianMonthName(int persianMonth) {
    switch (persianMonth) {
      case 1:
        return "فروردین";
      case 2:
        return "اردیبهشت";
      case 3:
        return "خرداد";
      case 4:
        return "تیر";
      case 5:
        return "مرداد";
      case 6:
        return "شهریور";
      case 7:
        return "مهر";
      case 8:
        return "آبان";
      case 9:
        return "آذر";
      case 10:
        return "دی";
      case 11:
        return "بهمن";
      case 12:
        return "اسفند";
      default:
        return "";
    }
  }

  static bool isLeapYear(int persianYear) {
    int remind = persianYear % 33;
    return (remind == 1 ||
        remind == 5 ||
        remind == 9 ||
        remind == 13 ||
        remind == 18 ||
        remind == 22 ||
        remind == 26 ||
        remind == 30);
  }

  static String toPersianDateFull(DateTime grDate) {
    String output = "";
    try {
      output += persianDayOfWeek(grDate);
      output += " " + toPersianDate(grDate) + " ";
      output += grDate.hour.toString() + ":" + grDate.minute.toString();
    } catch (exn) {}
    return output;
  }

  static String toPersianDateYYMMDDHHmm(DateTime grDate) {
    String output = "";
    try {
      output += toPersianDate(grDate) + " ";
      output += grDate.hour.toString() + ":" + grDate.minute.toString();
    } catch (exn) {}
    return output;
  }

  static String toPersianDate(DateTime grDate) {
    List<int> monthDays = [];

    monthDays.insert(0, 31);
    monthDays.insert(1, 31);
    monthDays.insert(2, 28);
    monthDays.insert(3, 31);
    monthDays.insert(4, 30);
    monthDays.insert(5, 31);
    monthDays.insert(6, 31);
    monthDays.insert(6, 30);
    monthDays.insert(7, 31);
    monthDays.insert(8, 31);
    monthDays.insert(9, 30);
    monthDays.insert(10, 31);
    monthDays.insert(11, 30);
    monthDays.insert(12, 31);
    int grDay = grDate.day;
    int grMonth = grDate.month;
    int grYear = grDate.year;
    int perYear;
    int perMonth;
    int perDays;
    int perDay;
    if (grYear % 4 == 0)
      monthDays[2] = 29;
    else
      monthDays[2] = 28;

    int grDays = grDay;
    if (grMonth > 1)
      for (int I = 1; I < grMonth; I++) grDays = grDays + monthDays[I];

    if (grDays < 80) {
      perYear = grYear - 622;
      perDays = grDays + 286;
      if (perYear % 4 == 3) perDays = perDays + 1;
    } else {
      perYear = grYear - 621;
      perDays = grDays - 79;
    }
    perDay = perDays;
    if (perDays <= 186)
      for (perMonth = 0; perDay > 31; perMonth++) {
        if (perDay > 30) perDay = perDay - 31;
      }
    else {
      perDay = perDay - 186;
      for (perMonth = 6; perDay > 30; perMonth++) {
        perDay = perDay - 30;
      }
    }

    perMonth = perMonth + 1;

    String strOut = perYear.toString().padLeft(4) +
        "/" +
        perMonth.toString() +
        "/" +
        perDay.toString();

    return (strOut);
  }

  static DateTime toGregorianDate(String perDate) {
    bool isValid;
    DateTime output = new DateTime(1900, 1, 1);
    int perDays, grYear = 0, grDays = 0, grDay = 0, grMonth = 0;
    List<int> monthDays = [];

    monthDays.insert(0, 31);
    monthDays.insert(1, 31);
    monthDays.insert(2, 31);
    monthDays.insert(3, 31);
    monthDays.insert(4, 30);
    monthDays.insert(5, 31);
    monthDays.insert(6, 31);
    monthDays.insert(6, 30);
    monthDays.insert(7, 31);
    monthDays.insert(8, 31);
    monthDays.insert(9, 30);
    monthDays.insert(10, 31);
    monthDays.insert(11, 30);
    monthDays.insert(12, 31);

    try {
      String strBuffer = perDate.substring(0, perDate.indexOf("/"));
      int perYear = int.parse(strBuffer);
      perDate = perDate.substring(perDate.indexOf("/") + 1);

      strBuffer = perDate.substring(0, perDate.indexOf("/"));
      int perMonth = int.parse(strBuffer);
      perDate = perDate.substring(perDate.indexOf("/") + 1);
      //strBuffer = Sh_Date.substring(0, Sh_Date.indexOf(" "));

      int perDay = int.parse(perDate);
      isValid = true;
      if (perMonth < 7 && perDay > 31) isValid = false;
      if (7 < perMonth && perMonth < 11 && perDay > 30) isValid = false;
      if (perMonth == 12) if ((perYear % 4 == 3 && perDay > 30) ||
          (perYear % 4 != 3 && perDay > 29)) isValid = false;
      if (perMonth > 12 || perMonth < 1) isValid = false;
      if (!isValid) return (DateTime.parse("1900-01-01 00:00:00"));

      if (perMonth <= 7)
        perDays = 31 * perMonth + perDay - 31;
      else
        perDays = 30 * perMonth + perDay - 24;

      int isLeapYear = perYear % 4;
      if (isLeapYear == 3 && perDays <= 287) {
        grYear = perYear + 621;
        grDays = perDays + 79;
      } else if (isLeapYear == 3 && perDays > 287) {
        grYear = perYear + 622;
        grDays = perDays - 287;
      } else if (isLeapYear != 3 && perDays <= 286) {
        grYear = perYear + 621;
        grDays = perDays + 79;
      } else if (isLeapYear != 3 && perDays > 286) {
        grYear = perYear + 622;
        grDays = perDays - 286;
      }

      if (grYear % 4 == 0)
        monthDays[2] = 29;
      else
        monthDays[2] = 28;

      grDay = grDays;
      bool done = false;
      for (grMonth = 1; grMonth < 13 && !done; grMonth++) {
        if (grDay <= monthDays[grMonth])
          done = true;
        else
          grDay = grDay - monthDays[grMonth];
      }
      grMonth--;
      strBuffer = grYear.toString() +
          "-" +
          grMonth.toString().padLeft(2, '0') +
          "-" +
          grDay.toString().padLeft(2, '0') +
          " 00:00:00";
      output = DateTime.parse(strBuffer); // "1900-01-01 00:00:00")
      return (output);
    } catch (exp) {
      return (DateTime.parse("1900-01-01 00:00:00"));
    }
  }
}
